var usernick=''
let ACT_EDITTEXT=1;
let ACT_TEST=2;
let ACT_END=3;
let ACT_SETT=4;
let version = "1.0.js-2"
var action=null

var userText=""
var dateString=''
var action=''
let chars = ['k', 's', 'p', 'd', 'h', 'e', 'm', 'y']
var cardArray = []
var step=-1
var substep=0

var userAnswer=[]

function saveState()
{
    sessionStorage.setItem('action', action); 
    sessionStorage.setItem('step', step);
    sessionStorage.setItem('order',order);
    sessionStorage.setItem('substep',substep);
    sessionStorage.setItem('userText', userText);
    sessionStorage.setItem('userAnswer', JSON.stringify( userAnswer));
    sessionStorage.setItem('cardArray', JSON.stringify( cardArray));

}

function loadState(){
    if(sessionStorage.getItem('step') != null){
        step = parseInt(sessionStorage.getItem('step'));
        substep= parseInt(sessionStorage.getItem('substep'));
        order= parseInt (sessionStorage.getItem('order'));
    }
    else{
        step = -1
    }

    action=parseInt(sessionStorage.getItem('action'));

    if(sessionStorage.getItem('userText')) userText=sessionStorage.getItem('userText');
    if( sessionStorage.getItem('userAnswer')) userAnswer= JSON.parse( sessionStorage.getItem('userAnswer'));
    if( sessionStorage.getItem('cardArray')) cardArray= JSON.parse( sessionStorage.getItem('cardArray'));
    
}

var randomizeCards=true
function savesettings(){
    localStorage.setItem('usernick', usernick);
}

function button_savenick(){
    let tmpInput=document.getElementById("usernick_input");
    tmp_usernick=tmpInput.value
    if(!tmp_usernick ){
      alert("Введите имя!")
    }
    else{
        usernick=tmp_usernick;
        buttonSaveSettings();
    }
}

function justSetNick(){
    
    let mydiv = document.getElementById("main");
    mydiv.innerHTML='<h1>Введите краткий псевдоним</h1><input type="text" id="usernick_input"></input><p><button id="buttonSavenick" onclick="button_savenick();">Сохранить</button></p> <button id="gotoStart" onclick="gotoStart()" >Вернуться</button>'

    
}

function gotoStart(){
    if(! usernick){
        justSetNick();
    }
    startSPR();
}


function init() {
    document.title="Тест ЭДВ " + version
    var ua = navigator.userAgent.toLowerCase(); 
    var isAndroid = ua.indexOf("android") > -1; 
    if(isAndroid) {
      var parandroid = document.getElementById("parAndroid");
      parandroid.innerHTML = 'У вас «андроид»? Возможно, имеет смысл <a href="https://play.google.com/store/apps/details?id=ru.erinaceto.sprtest">установить приложение</a>.';
    }
    else if (window.location.protocol == "file:"  || window.location.host == "localhost" || window.location.host == "127.0.0.1"){
      var parandroid = document.getElementById("parAndroid");
      parandroid.innerHTML='Версия '+version+', текущая версия <iframe scrolling="no" width="80" height="20" src="http://sprtest.website.yandexcloud.net/files/sprtest_link.html">Недоступно</iframe>'
    }
    

    readsettings();
    
    loadState();
    if((action >0) && confirm("Тест был прерван (возможно, страница была перезагружена). Продолжить?")){
            switch(action){
                case ACT_EDITTEXT: enter_usertext(); break;
                case ACT_TEST:  drawCards(); break;
                case ACT_END: gotoEndTest(); break;
                case ACT_SETT: gotoSettings(); break;

        }

    }
    else{

        
        step=0;
        substep=0;
        sessionStorage.clear();
        setCards();
        gotoStart();
    }
     
}




window.onload = init();
function rnd(min, max) {
  let rand = min + Math.random() * (max + 1 - min);
  return Math.floor(rand);
}

function setCards(){
    if(step < 5 ){
        for (var s=1; s<=6; s++){
            cardArray[s-1] = new Array(s+ "_k", s+ "_s", s+ "_p",s+ "_d",s+ "_h",s+ "_e",s+ "_m",s+ "_y" );
            userAnswer[s-1] = new Array('-','-','-','-','-','-','-','-')
        }
        if(randomizeCards == true){
            var tmpCard='';
            for (var s=0;s<6;s++){
                for (var n=0; n<4; n++){
                    let n1 = rnd(0,7);
                    let n2 = rnd(0,7);
                    
                    tmpCard = cardArray[s][n1];
                    cardArray[s][n1] = cardArray[s][n2];
                    cardArray[s][n2] = tmpCard ;
                }
                let n1 = rnd(0,5);
                let n2 = rnd(0,5);
                for (var c=0;c<8; c++){
                    tmpCard = cardArray[n1][c];
                    cardArray[n1][c] = cardArray[n2][c];
                    cardArray[n2][c] = tmpCard ;
                }
            }
        }

    }
    else { //step==6; two asserts, btw
        for (var s=0; s<6;s++){
            for(c=0;c<4;c++){
                var i=1
                while(cardArray[s][c] == 'blank'){
                    cardArray[s][c] = cardArray[s][c+i];
                    cardArray[s][c+i] = 'blank';
                    i++;
                }
            }
        }
    }
}

var wCards


function drawOneCard(s,n){

    let ccDiv= document.getElementById("cardDiv" + n)
    var ccard_onclick
    var ccard

    if (s == "blank")
    {
        ccard="blank";
        ccard_onclick=''
    }
    else{
        ccard=cardArray[s][n];
        ccard_onclick=' onclick="click1(this)" '
            
    }
    
    var htmlCard='<img '+ ccard_onclick + '  id="img'+ n + '" ';
    htmlCard += ' src="files/cards/'+cardSet+'/'+ ccard + '" ';
    if(wCards == 4){ //album
        htmlCard += ' align="left" width="20%" height="" border="1%"/> ';
    }
    else{
        htmlCard +=  ' align="left" width="" height="20%" border="1%"/> ';
    }

    
    ccDiv.innerHTML=htmlCard;
}

function drawCards(){

        action=ACT_TEST
    
    var htmlCards=""
    
    if(window.innerWidth > window.innerHeight) { // album
        wCards = 4;
        hCards = 2;
    }
    else{ // book
        wCards = 2;
        hCards = 4;
    }
    
    if (step < 6){
        for (var i = 0; i<hCards; i++){
            htmlCards+='<p><div style="clear:both">'
            for(var j = 0;  j<wCards; j++){
                htmlCards += ' <div align="left" id="cardDiv' + ( i*wCards+j) + '"></div>'

                
            }
            htmlCards+='</div></p>'
        }

        var cardsLayout= document.getElementById("main");
        cardsLayout.innerHTML=htmlCards;
        
        for (var i = 0; i<hCards; i++){
            for(var j = 0;  j<wCards; j++){
                drawOneCard(step , i*wCards+j)
            }
        }
    }
    else if( step < 12){//step>=6
//        if(step==6){
            setCards();
//        }
        
        for (var i = 0; i<2; i++){
            htmlCards+='<p><div style="clear:both">'
            for(var j = 0;  j<2; j++){
                htmlCards += ' <div align="left" id="cardDiv' + ( i*2+j) + '"></div>'
            }
            htmlCards+='</div></p>'
        }

        var cardsLayout= document.getElementById("main");
        cardsLayout.innerHTML=htmlCards;
        
        for (var i = 0; i<2; i++){
            for(var j = 0;  j<2; j++){
                drawOneCard(step %6, i*2+j)
            }
        }
    }
}



function gotoEndTest(){
    if(userText == ""){
        enter_usertext()
    }
    else{
        action=ACT_END
        refineAnswer();
        makeCSV();
        let mydiv=document.getElementById("main")
        mydiv.innerHTML=""
        mydiv.innerHTML='<button id="button_entertext" onclick="click_mainbutton(this)">Дополнить описание</button>\n\
        <button id="button_endtest" onclick="click_mainbutton(this)">Сохранить результат</button> в кодировке: <select  id="charset">\n\
        <option value="cp-1251">для M$ Office</option><option value="utf-8">стандартной</option></select> <a href="mailto:"' + mail_address+ '?subject="Testing%20%on%20'+dateString+'">Открыть почту (если настроена в браузере)</a>'
    }
}

function refineAnswer(){
    for (var  s=0; s<6;s++ ){
        var d=6 //order of symbol in the current step (step as defined by local 's' in th loop). d should be 6 or (on the second pass) 7
	for (var c =0; c<8; c++){
	var cNotFound = true;
	    for (ic=0;ic<8;ic++){
		if (userAnswer[s][ic] == chars[c]){
		    cNotFound = false;
		    break
		}
	    }
	    if(cNotFound){
		userAnswer[s][d] = chars[c]
		d++;
	    }
	}
    }
}

function click1(e){
    
    action=ACT_TEST
    let n=e.id[e.id.length-1]
    drawOneCard ( "blank",  n)
    

    if(step<6){
	if(substep<2){
            order = substep
        }
        else{
    	    order = 5-substep
    	}
    }
    else
    {
        switch(substep){
            case 0: order = 5; break;
            case 1: order = 4; break;
        }
    }
    substep++;
    userAnswer[step%6][order] = (cardArray[step%6][ document.getElementById("img" + e.id[e.id.length-1]).id[3] ])[2]

    cardArray[step%6][n] = 'blank'

    
    
    if(substep == 4 || (step > 5 && substep == 2)){
        step++
        substep=0
        order=0
        drawCards()
    }
    if(step == 12){
        gotoEndTest()
    }
    saveState();
}

function readsettings (){
    if (localStorage.getItem('usernick')){
        usernick = localStorage.getItem('usernick')
    }
    else if(default_usernick == ""){
        justSetNick();
        
    }
    else{
        usernick=default_usernick
    }
    if(localStorage.getItem('mail_address')){
        mail_address=localStorage.getItem('mail_address')
    }
    else{
        mail_address=default_emailAddress
    }

    
    cardSet="default"
    if(cardSet == '' || typeof(cardSet) == 'undefined' || cardSet == null)
    {
        cardSet=default_cardSet
    }
    savesettings();

    
}

function resizeListener(){
    if (action == ACT_TEST && step >=0  && step <6){
        drawCards();
    }
}

window.addEventListener('resize', resizeListener);

function makeCSV(){
      csv=usernick+';'
    let now = new Date()
    
    
    dateString=String(now.getFullYear())+'-'+String(now.getMonth()+1)+ '-' + String(now.getDate())+'_' + String(now.getHours())+'.'+String(now.getMinutes())
    csv+= dateString +';'
    for (var s=0; s<6; s++){
        for (var c=0; c<8; c++){
            csv += userAnswer[s][c]
        }
        csv+=';'
    }
    csv+=userText+';Данные из онлайн-версии 1.10.js-2'
}

function downloadCSV(){
  
    let  dCSV = document.getElementById('pCSV')
    action=-1
    /*
<script type="application/javascript">
</script>*/

    

    var element = document.createElement('a');
    let charsetid=document.getElementById("charset")
    if(charsetid.value == "cp-1251"){
	element.setAttribute('href', 'data:text/plain;charset=cp-1251,' + unicodeToWin1251_UrlEncoded(csv));

    }
    else{
	element.setAttribute('href', 'data:text/plain;charset=utf-8,' + encodeURIComponent(csv));
    }
    element.setAttribute('download', dateString+'.csv');
    element.style.display = 'none';
    
    document.body.appendChild(element);
    
    element.click();
    
    document.body.removeChild(element);

    
}


function click_mainbutton(e){
    if (e.id == "button_endtest"){
        downloadCSV();
    }
    else if(e.id == "button_starttest"){
	ninput = document.getElementById("usernick_input");
	if(ninput.value != "")
	{
	    usernick = ninput.value;
	}
        drawCards();
    }
    else if (e.id == "button_setting"){
        gotoSettings();
    }
    else if (e.id == "button_entertext"){
        enter_usertext()
    }
}

function button_savetext(){
    let input = document.getElementById("usertext")
    userText=input.value
    if(step <=0){   
         startSPR()
    }
    else{
        gotoEndTest()
    }
}


window.addEventListener('beforeunload', function (e) { 
    if (action == ACT_EDITTEXT){
        let input = document.getElementById("usertext")
        userText=input.value
    }
    saveState();
    
})

function enter_usertext(){
    action=ACT_EDITTEXT
    mydiv = document.getElementById("main");
    htmlEnter  = '<h1>Опишите двумя-тремя фразами своё эмоциональное состояние</h1><textarea cols="50" rows="5" type="text" id=usertext>'
    htmlEnter += userText
    if(step>0 &&  userText != "" && (!userText.endsWith('PS. '))){// step>0 - for the case if we several time invoke function at beginning (we dont need then add "ps.")
        htmlEnter+='\nPS. '
    }
    htmlEnter +='</textarea><p><button id="button_usertext" onclick="button_savetext()">Сохранить</button></p>'

    mydiv.innerHTML=htmlEnter
    
}



function startSPR(){
    setCards()

    let mydiv=document.getElementById("main");

    if( typeof( usernick ) == "undefined"  || usernick == "undefined" || usernick == ''){
        justSetNick();
    }

    mydiv.innerHTML='<button id="button_entertext" onclick="click_mainbutton(this)">Ввести описание</button>\n\
    <button id="button_starttest" onclick="click_mainbutton(this)">Начать тест</button> Псевдоним: <input type="text" id="usernick_input"></input>'
    let input = document.getElementById("usernick_input")
    input.value=usernick;

}

var DMap = {0: 0, 1: 1, 2: 2, 3: 3, 4: 4, 5: 5, 6: 6, 7: 7, 8: 8, 9: 9, 10: 10, 11: 11, 12: 12, 13: 13, 14: 14, 15: 15, 16: 16, 17: 17, 18: 18, 19: 19, 20: 20, 21: 21, 22: 22, 23: 23, 24: 24, 25: 25, 26: 26, 27: 27, 28: 28, 29: 29, 30: 30, 31: 31, 32: 32, 33: 33, 34: 34, 35: 35, 36: 36, 37: 37, 38: 38, 39: 39, 40: 40, 41: 41, 42: 42, 43: 43, 44: 44, 45: 45, 46: 46, 47: 47, 48: 48, 49: 49, 50: 50, 51: 51, 52: 52, 53: 53, 54: 54, 55: 55, 56: 56, 57: 57, 58: 58, 59: 59, 60: 60, 61: 61, 62: 62, 63: 63, 64: 64, 65: 65, 66: 66, 67: 67, 68: 68, 69: 69, 70: 70, 71: 71, 72: 72, 73: 73, 74: 74, 75: 75, 76: 76, 77: 77, 78: 78, 79: 79, 80: 80, 81: 81, 82: 82, 83: 83, 84: 84, 85: 85, 86: 86, 87: 87, 88: 88, 89: 89, 90: 90, 91: 91, 92: 92, 93: 93, 94: 94, 95: 95, 96: 96, 97: 97, 98: 98, 99: 99, 100: 100, 101: 101, 102: 102, 103: 103, 104: 104, 105: 105, 106: 106, 107: 107, 108: 108, 109: 109, 110: 110, 111: 111, 112: 112, 113: 113, 114: 114, 115: 115, 116: 116, 117: 117, 118: 118, 119: 119, 120: 120, 121: 121, 122: 122, 123: 123, 124: 124, 125: 125, 126: 126, 127: 127, 1027: 129, 8225: 135, 1046: 198, 8222: 132, 1047: 199, 1168: 165, 1048: 200, 1113: 154, 1049: 201, 1045: 197, 1050: 202, 1028: 170, 160: 160, 1040: 192, 1051: 203, 164: 164, 166: 166, 167: 167, 169: 169, 171: 171, 172: 172, 173: 173, 174: 174, 1053: 205, 176: 176, 177: 177, 1114: 156, 181: 181, 182: 182, 183: 183, 8221: 148, 187: 187, 1029: 189, 1056: 208, 1057: 209, 1058: 210, 8364: 136, 1112: 188, 1115: 158, 1059: 211, 1060: 212, 1030: 178, 1061: 213, 1062: 214, 1063: 215, 1116: 157, 1064: 216, 1065: 217, 1031: 175, 1066: 218, 1067: 219, 1068: 220, 1069: 221, 1070: 222, 1032: 163, 8226: 149, 1071: 223, 1072: 224, 8482: 153, 1073: 225, 8240: 137, 1118: 162, 1074: 226, 1110: 179, 8230: 133, 1075: 227, 1033: 138, 1076: 228, 1077: 229, 8211: 150, 1078: 230, 1119: 159, 1079: 231, 1042: 194, 1080: 232, 1034: 140, 1025: 168, 1081: 233, 1082: 234, 8212: 151, 1083: 235, 1169: 180, 1084: 236, 1052: 204, 1085: 237, 1035: 142, 1086: 238, 1087: 239, 1088: 240, 1089: 241, 1090: 242, 1036: 141, 1041: 193, 1091: 243, 1092: 244, 8224: 134, 1093: 245, 8470: 185, 1094: 246, 1054: 206, 1095: 247, 1096: 248, 8249: 139, 1097: 249, 1098: 250, 1044: 196, 1099: 251, 1111: 191, 1055: 207, 1100: 252, 1038: 161, 8220: 147, 1101: 253, 8250: 155, 1102: 254, 8216: 145, 1103: 255, 1043: 195, 1105: 184, 1039: 143, 1026: 128, 1106: 144, 8218: 130, 1107: 131, 8217: 146, 1108: 186, 1109: 190}

function unicodeToWin1251_UrlEncoded(s) {
    var L = []
    for (var i=0; i<s.length; i++) {
        var ord = s.charCodeAt(i)
        if (!(ord in DMap))
            throw "Character "+s.charAt(i)+" isn't supported by win1251!";
        L.push('%'+DMap[ord].toString(16));
    }
    return L.join('').toUpperCase();
}

